<!doctype html>

<!-- http://clicktorelease.com/code/perlin/green.html -->

<html lang="en">
	<head>
		<title>three.js webgl - render-to-texture Corinde</title>
		<meta charset="utf-8">
		<meta name="viewport" content="width=device-width, user-scalable=no, minimum-scale=1.0, maximum-scale=1.0">
		<script type="text/javascript">

/*
//<![CDATA[
try{if (!window.CloudFlare) {var CloudFlare=[{verbose:0,p:1429660913,byc:0,owlid:"cf",bag2:1,mirage2:0,oracle:0,paths:{cloudflare:"/cdn-cgi/nexp/dok3v=1613a3a185/"},atok:"6a9cac964fa122e6ee1d1552b11a96fe",petok:"5daffcc98f8728d0cac344ba066bb39aa0904014-1430416022-1800",zone:"clicktorelease.com",rocket:"0",apps:{"ga_key":{"ua":"UA-625393-26","ga_bs":"2"},"abetterbrowser":{"ie":"7"}}}];!function(a,b){a=document.createElement("script"),b=document.getElementsByTagName("script")[0],a.async=!0,a.src="//ajax.cloudflare.com/cdn-cgi/nexp/dok3v=7e13c32551/cloudflare.min.js",b.parentNode.insertBefore(a,b)}()}}catch(e){};
//]]>

*/

</script>
<style>
			body {
				color: #ffffff;
				font-family:Monospace;
				font-size:13px;
				text-align:center;
				font-weight: bold;
				background-color: #000000;
				margin: 0px;
				overflow: hidden;
			}
		</style>
</head>
	<body>

		<div id="container"></div>

<script src="three_green.js"></script>
<!-- <script src="js/three_71.js"></script> -->

<script src="detector_green.js"></script>
<script src="stats_green.js"></script>

<script type="x-shader/x-vertex" id="vertexShader">
//
// Description : Array and textureless GLSL 2D/3D/4D simplex 
//               noise functions.
//      Author : Ian McEwan, Ashima Arts.
//  Maintainer : ijm
//     Lastmod : 20110822 (ijm)
//     License : Copyright (C) 2011 Ashima Arts. All rights reserved.
//               Distributed under the MIT License. See LICENSE file.
//               https://github.com/ashima/webgl-noise
// 

vec3 mod289(vec3 x) {
  return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec4 mod289(vec4 x) {
  return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec4 permute(vec4 x) {
     return mod289(((x*34.0)+1.0)*x);
}

vec4 taylorInvSqrt(vec4 r)
{
  return 1.79284291400159 - 0.85373472095314 * r;
}

float snoise(vec3 v) {

  const vec2  C = vec2(1.0/6.0, 1.0/3.0) ;
  const vec4  D = vec4(0.0, 0.5, 1.0, 2.0);

// First corner
  vec3 i  = floor(v + dot(v, C.yyy) );
  vec3 x0 =   v - i + dot(i, C.xxx) ;

// Other corners
  vec3 g = step(x0.yzx, x0.xyz);
  vec3 l = 1.0 - g;
  vec3 i1 = min( g.xyz, l.zxy );
  vec3 i2 = max( g.xyz, l.zxy );

  //   x0 = x0 - 0.0 + 0.0 * C.xxx;
  //   x1 = x0 - i1  + 1.0 * C.xxx;
  //   x2 = x0 - i2  + 2.0 * C.xxx;
  //   x3 = x0 - 1.0 + 3.0 * C.xxx;
  vec3 x1 = x0 - i1 + C.xxx;
  vec3 x2 = x0 - i2 + C.yyy; // 2.0*C.x = 1/3 = C.y
  vec3 x3 = x0 - D.yyy;      // -1.0+3.0*C.x = -0.5 = -D.y

// Permutations
  i = mod289(i); 
  vec4 p = permute( permute( permute( 
             i.z + vec4(0.0, i1.z, i2.z, 1.0 ))
           + i.y + vec4(0.0, i1.y, i2.y, 1.0 )) 
           + i.x + vec4(0.0, i1.x, i2.x, 1.0 ));

// Gradients: 7x7 points over a square, mapped onto an octahedron.
// The ring size 17*17 = 289 is close to a multiple of 49 (49*6 = 294)
  float n_ = 0.142857142857; // 1.0/7.0
  vec3  ns = n_ * D.wyz - D.xzx;

  vec4 j = p - 49.0 * floor(p * ns.z * ns.z);  //  mod(p,7*7)

  vec4 x_ = floor(j * ns.z);
  vec4 y_ = floor(j - 7.0 * x_ );    // mod(j,N)

  vec4 x = x_ *ns.x + ns.yyyy;
  vec4 y = y_ *ns.x + ns.yyyy;
  vec4 h = 1.0 - abs(x) - abs(y);

  vec4 b0 = vec4( x.xy, y.xy );
  vec4 b1 = vec4( x.zw, y.zw );

  //vec4 s0 = vec4(lessThan(b0,0.0))*2.0 - 1.0;
  //vec4 s1 = vec4(lessThan(b1,0.0))*2.0 - 1.0;
  vec4 s0 = floor(b0)*2.0 + 1.0;
  vec4 s1 = floor(b1)*2.0 + 1.0;
  vec4 sh = -step(h, vec4(0.0));

  vec4 a0 = b0.xzyw + s0.xzyw*sh.xxyy ;
  vec4 a1 = b1.xzyw + s1.xzyw*sh.zzww ;

  vec3 p0 = vec3(a0.xy,h.x);
  vec3 p1 = vec3(a0.zw,h.y);
  vec3 p2 = vec3(a1.xy,h.z);
  vec3 p3 = vec3(a1.zw,h.w);

//Normalise gradients
  vec4 norm = taylorInvSqrt(vec4(dot(p0,p0), dot(p1,p1), dot(p2, p2), dot(p3,p3)));
  p0 *= norm.x;
  p1 *= norm.y;
  p2 *= norm.z;
  p3 *= norm.w;

// Mix final noise value
  vec4 m = max(0.6 - vec4(dot(x0,x0), dot(x1,x1), dot(x2,x2), dot(x3,x3)), 0.0);
  m = m * m;
  return 42.0 * dot( m*m, vec4( dot(p0,x0), dot(p1,x1), 
                                dot(p2,x2), dot(p3,x3) ) );
  }
	
	varying vec2 vUv;
	varying vec3 vReflect;
	varying vec3 pos;
	varying float ao;
	uniform float time;
	uniform float weight;
	varying float d;

	float stripes( float x, float f) {
		float PI = 3.14159265358979323846264;
		float t = .5 + .5 * sin( f * 2.0 * PI * x);
		return t * t - .5;
	}
	
	float turbulence( vec3 p ) {
		float w = 100.0;
		float t = -.5;
		for (float f = 1.0 ; f <= 10.0 ; f++ ){
			float power = pow( 2.0, f );
			t += abs( snoise( vec3( power * p ) + time ) / power );
		}
		return t;
	}

	void main() {

		vUv = uv;
	
		vec4 mPosition = objectMatrix * vec4( position, 1.0 );
		vec3 nWorld = normalize( mat3( objectMatrix[0].xyz, objectMatrix[1].xyz, objectMatrix[2].xyz ) * normal );
		vReflect = normalize( reflect( normalize( mPosition.xyz - cameraPosition ), nWorld ) );
		
		pos = position;
		//float noise = .3 * snoise( 8.0 * vec3( normal ) );
		float noise = 10.0 * -.10 * turbulence( .5 * normal );
		//float noise = - stripes( normal.x + 2.0 * turbulence( normal ), 1.6 );

		float displacement = - weight * noise;
		ao = noise;
		vec3 newPosition = position + normal * vec3( displacement );
		gl_Position = projectionMatrix * modelViewMatrix * vec4( newPosition, 1.0 );
	
	}

	</script>
	
	<script type="x-shader/x-vertex" id="fragmentShader">

	varying vec2 vUv;
	uniform sampler2D tExplosion;
	varying vec3 vReflect;
	varying vec3 pos;
	varying float ao;
	varying float d;
	float PI = 3.14159265358979323846264;

	void main() {

		vec3 color = texture2D( tExplosion, vec2( 0, .85 - ao ) ).rgb;
		gl_FragColor = vec4( color.rgb, 1.0 );

	}
	
	</script>
	
<script>

var container, renderer, scene, camera, mesh;
var start = Date.now();

window.addEventListener( 'load', init );

function init() {

	container = document.getElementById( 'container' );
	
	scene = new THREE.Scene();

	camera = new THREE.PerspectiveCamera( 30, window.innerWidth / window.innerHeight, 1, 10000 );
	camera.position.z = 100;
	camera.target = new THREE.Vector3( 0, 0, 0 );

	scene.add( camera );
	
	material = new THREE.ShaderMaterial( {

		uniforms: { 
			tExplosion: { type: "t", value: 0, texture: THREE.ImageUtils.loadTexture( 'green.png' ) },
			time: { type: "f", value: 0.0 },
			weight: { type: "f", value: 10.0 }
		},
		vertexShader: document.getElementById( 'vertexShader' ).textContent,
		fragmentShader: document.getElementById( 'fragmentShader' ).textContent
		
	} );
	
	mesh = new THREE.Mesh( new THREE.SphereGeometry( 20, 200, 200 ), material );
	mesh = new THREE.Mesh( new THREE.SphereGeometry( 20, 200, 200 ), material );
	scene.add( mesh );
	
	renderer = new THREE.WebGLRenderer();
	renderer.setSize( window.innerWidth, window.innerHeight );
	renderer.autoClear = false;

	container.appendChild( renderer.domElement );

	container.addEventListener( 'mousedown', onMouseDown, false );
	container.addEventListener( 'mousemove', onMouseMove, false );
	container.addEventListener( 'mouseup', onMouseUp, false );

	render();
	
}

var onMouseDownMouseX = 0, onMouseDownMouseY = 0,
lon = 0, onMouseDownLon = 0,
lat = 0, onMouseDownLat = 0,
phi = 0, theta = 0;
lat = 15, isUserInteracting = false;


function onMouseDown( event ) {

	event.preventDefault();

	isUserInteracting = true;

	onPointerDownPointerX = event.clientX;
	onPointerDownPointerY = event.clientY;

	onPointerDownLon = lon;
	onPointerDownLat = lat;

}

function onMouseMove( e ) {

	if ( isUserInteracting ) {
	
		lon = ( event.clientX - onPointerDownPointerX ) * 0.1 + onPointerDownLon;
		lat = ( event.clientY - onPointerDownPointerY ) * 0.1 + onPointerDownLat;
		
	}
	
	//material.uniforms[ 'weight' ].value = e.pageX * 10.0 / window.innerWidth;;

}

function onMouseUp( event ) {
	
	isUserInteracting = false;

}

var scale = 0;

function render() {

	material.uniforms[ 'time' ].value = .0001 * ( Date.now() - start );
	//mesh.scale.set( scale, scale, scale );
	scale += .005;
	scale %= 2;
	
	lat = Math.max( - 85, Math.min( 85, lat ) );
	phi = ( 90 - lat ) * Math.PI / 180;
	theta = lon * Math.PI / 180;

	camera.position.x = 100 * Math.sin( phi ) * Math.cos( theta );
	camera.position.y = 100 * Math.cos( phi );
	camera.position.z = 100 * Math.sin( phi ) * Math.sin( theta );

	camera.lookAt( camera.target );
	
	//mesh.rotation.x += .012;
	//mesh.rotation.y += .01;
	camera.lookAt( scene.position );
	
	renderer.render( scene, camera );
	requestAnimationFrame( render );
	
}

</script>
		
	</body>
</html>
